"""
This type stub file was generated by pyright.
"""

from .base import Executable as Executable, Generative as Generative
from .elements import BinaryExpression as BinaryExpression, ColumnElement as ColumnElement, NamedColumn as NamedColumn
from .selectable import FromClause as FromClause
from .visitors import TraversibleType as TraversibleType
from typing import Any, Optional

def register_function(identifier: Any, fn: Any, package: str = ...) -> None:
    ...

class FunctionElement(Executable, ColumnElement, FromClause, Generative):
    packagenames: Any = ...
    clause_expr: Any = ...
    def __init__(self, *clauses: Any, **kwargs: Any) -> None:
        ...
    
    def scalar_table_valued(self, name: Any, type_: Optional[Any] = ...):
        ...
    
    def table_valued(self, *expr: Any, **kw: Any):
        ...
    
    def column_valued(self, name: Optional[Any] = ...):
        ...
    
    @property
    def columns(self):
        ...
    
    @property
    def exported_columns(self):
        ...
    
    def clauses(self):
        ...
    
    def over(self, partition_by: Optional[Any] = ..., order_by: Optional[Any] = ..., rows: Optional[Any] = ..., range_: Optional[Any] = ...):
        ...
    
    def within_group(self, *order_by: Any):
        ...
    
    def filter(self, *criterion: Any):
        ...
    
    def as_comparison(self, left_index: Any, right_index: Any):
        ...
    
    def within_group_type(self, within_group: Any) -> None:
        ...
    
    def alias(self, name: Optional[Any] = ...):
        ...
    
    def select(self):
        ...
    
    def scalar(self):
        ...
    
    def execute(self):
        ...
    
    def self_group(self, against: Optional[Any] = ...):
        ...
    
    @property
    def entity_namespace(self):
        ...
    


class FunctionAsBinary(BinaryExpression):
    sql_function: Any = ...
    left_index: Any = ...
    right_index: Any = ...
    operator: Any = ...
    type: Any = ...
    negate: Any = ...
    modifiers: Any = ...
    def __init__(self, fn: Any, left_index: Any, right_index: Any) -> None:
        ...
    
    @property
    def left(self):
        ...
    
    @left.setter
    def left(self, value: Any) -> None:
        ...
    
    @property
    def right(self):
        ...
    
    @right.setter
    def right(self, value: Any) -> None:
        ...
    


class ScalarFunctionColumn(NamedColumn):
    __visit_name__: str = ...
    is_literal: bool = ...
    table: Any = ...
    fn: Any = ...
    name: Any = ...
    type: Any = ...
    def __init__(self, fn: Any, name: Any, type_: Optional[Any] = ...) -> None:
        ...
    


class _FunctionGenerator:
    opts: Any = ...
    def __init__(self, **opts: Any) -> None:
        ...
    
    def __getattr__(self, name: Any):
        ...
    
    def __call__(self, *c: Any, **kwargs: Any):
        ...
    


func: Any
modifier: Any
class Function(FunctionElement):
    __visit_name__: str = ...
    type: Any = ...
    packagenames: Any = ...
    name: Any = ...
    def __init__(self, name: Any, *clauses: Any, **kw: Any) -> None:
        ...
    


class _GenericMeta(TraversibleType):
    def __init__(cls, clsname: Any, bases: Any, clsdict: Any) -> None:
        ...
    


class GenericFunction:
    coerce_arguments: bool = ...
    inherit_cache: bool = ...
    packagenames: Any = ...
    clause_expr: Any = ...
    type: Any = ...
    def __init__(self, *args: Any, **kwargs: Any) -> None:
        ...
    


class next_value(GenericFunction):
    type: Any = ...
    name: str = ...
    sequence: Any = ...
    def __init__(self, seq: Any, **kw: Any) -> None:
        ...
    
    def compare(self, other: Any, **kw: Any):
        ...
    


class AnsiFunction(GenericFunction):
    inherit_cache: bool = ...
    def __init__(self, *args: Any, **kwargs: Any) -> None:
        ...
    


class ReturnTypeFromArgs(GenericFunction):
    inherit_cache: bool = ...
    def __init__(self, *args: Any, **kwargs: Any) -> None:
        ...
    


class coalesce(ReturnTypeFromArgs):
    inherit_cache: bool = ...


class max(ReturnTypeFromArgs):
    inherit_cache: bool = ...


class min(ReturnTypeFromArgs):
    inherit_cache: bool = ...


class sum(ReturnTypeFromArgs):
    inherit_cache: bool = ...


class now(GenericFunction):
    type: Any = ...
    inherit_cache: bool = ...


class concat(GenericFunction):
    type: Any = ...
    inherit_cache: bool = ...


class char_length(GenericFunction):
    type: Any = ...
    inherit_cache: bool = ...
    def __init__(self, arg: Any, **kwargs: Any) -> None:
        ...
    


class random(GenericFunction):
    inherit_cache: bool = ...


class count(GenericFunction):
    type: Any = ...
    inherit_cache: bool = ...
    def __init__(self, expression: Optional[Any] = ..., **kwargs: Any) -> None:
        ...
    


class current_date(AnsiFunction):
    type: Any = ...
    inherit_cache: bool = ...


class current_time(AnsiFunction):
    type: Any = ...
    inherit_cache: bool = ...


class current_timestamp(AnsiFunction):
    type: Any = ...
    inherit_cache: bool = ...


class current_user(AnsiFunction):
    type: Any = ...
    inherit_cache: bool = ...


class localtime(AnsiFunction):
    type: Any = ...
    inherit_cache: bool = ...


class localtimestamp(AnsiFunction):
    type: Any = ...
    inherit_cache: bool = ...


class session_user(AnsiFunction):
    type: Any = ...
    inherit_cache: bool = ...


class sysdate(AnsiFunction):
    type: Any = ...
    inherit_cache: bool = ...


class user(AnsiFunction):
    type: Any = ...
    inherit_cache: bool = ...


class array_agg(GenericFunction):
    type: Any = ...
    inherit_cache: bool = ...
    def __init__(self, *args: Any, **kwargs: Any) -> None:
        ...
    


class OrderedSetAgg(GenericFunction):
    array_for_multi_clause: bool = ...
    inherit_cache: bool = ...
    def within_group_type(self, within_group: Any):
        ...
    


class mode(OrderedSetAgg):
    inherit_cache: bool = ...


class percentile_cont(OrderedSetAgg):
    array_for_multi_clause: bool = ...
    inherit_cache: bool = ...


class percentile_disc(OrderedSetAgg):
    array_for_multi_clause: bool = ...
    inherit_cache: bool = ...


class rank(GenericFunction):
    type: Any = ...
    inherit_cache: bool = ...


class dense_rank(GenericFunction):
    type: Any = ...
    inherit_cache: bool = ...


class percent_rank(GenericFunction):
    type: Any = ...
    inherit_cache: bool = ...


class cume_dist(GenericFunction):
    type: Any = ...
    inherit_cache: bool = ...


class cube(GenericFunction):
    inherit_cache: bool = ...


class rollup(GenericFunction):
    inherit_cache: bool = ...


class grouping_sets(GenericFunction):
    inherit_cache: bool = ...


